#!/usr/bin/perl -T
###################################################################################
#   this file is part of c2h
#   Copyright (C)2005 Bruce Park ( jongsuknim@naver.com )
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   as published by the Free Software Foundation; either
#   version 2 of the License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###################################################################################/

@list = ("Aml", "Asm", "Awk", "C", "Cobol", "Csharp", "Eiffel", "Fortran", "Make",
    "Html", "Java", "Jscript", "Lisp", "Lua", "Pascal", "Perl", "Php",
    "Python", "Rexx", "Ruby", "Scheme", "Tcl_tk", "Shell", "Verilog");
foreach( @list){

    print "#ifdef   ".uc($_)."_FILE_EXTENSIONS\n";
    print "static char *".lc($_)."_file_extensions[]	=   {".uc($_)."_FILE_EXTENSIONS};\n";
    print "#else\n";
    print "static char *".lc($_)."_file_extensions[]	=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_KEYWORDS\n";
    print "static char *".lc($_)."_keywords[]		=   {".uc($_)."_KEYWORDS};\n";
    print "#else\n";
    print "static char *".lc($_)."_keywords[]		=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_BLOCK_COMMENT_ON\n";
    print "static char *".lc($_)."_block_cmt_on[]		=   {".uc($_)."_BLOCK_COMMENT_ON};\n";
    print "#else\n";
    print "static char *".lc($_)."_block_cmt_on[]		=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_BLOCK_COMMENT_OFF\n";
    print "static char *".lc($_)."_block_cmt_off[]		=   {".uc($_)."_BLOCK_COMMENT_OFF};\n";
    print "#else\n";
    print "static char *".lc($_)."_block_cmt_off[]		=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_KEYWORDS1\n";
    print "static char *".lc($_)."_keywords1[]		=   {".uc($_)."_KEYWORDS1};\n\n"; 
    print "#else\n";
    print "static char *".lc($_)."_keywords1[]		=   {NULL};\n";
    print "#endif\n\n\n";

    print "#ifdef   ".uc($_)."_KEYWORDS2\n";
    print "static char *".lc($_)."_keywords2[]		=   {".uc($_)."_KEYWORDS2};\n\n"; 
    print "#else\n";
    print "static char *".lc($_)."_keywords2[]		=   {NULL};\n";
    print "#endif\n\n\n";

    print "#ifdef   ".uc($_)."_KEYWORD_BLOCK_ON\n";
    print "static char *".lc($_)."_keyword_block_on[]		=   {".uc($_)."_KEYWORD_BLOCK_ON};\n";
    print "#else\n";
    print "static char *".lc($_)."_keyword_block_on[]		=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_KEYWORD_BLOCK_OFF\n";
    print "static char *".lc($_)."_keyword_block_off[]		=   {".uc($_)."_KEYWORD_BLOCK_OFF};\n";
    print "#else\n";
    print "static char *".lc($_)."_keyword_block_off[]		=   {NULL};\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_DOUBLE_REGEXP_ON\n";
    print "static char *".lc($_)."_double_regexp_on[]		=   {".uc($_)."_DOUBLE_REGEXP_ON};\n";
    print "#else\n";
    print "static char *".lc($_)."_double_regexp_on[]		=   {NULL};\n";
    print "#endif\n\n";
    
    print "#ifdef   ".uc($_)."_SINGLE_REGEXP_ON\n";
    print "static char *".lc($_)."_single_regexp_on[]		=   {".uc($_)."_SINGLE_REGEXP_ON};\n";
    print "#else\n";
    print "static char *".lc($_)."_single_regexp_on[]		=   {NULL};\n";
    print "#endif\n\n";
    
    print "#ifdef   ".uc($_)."_REGEXP_OFF\n";
    print "static char *".lc($_)."_regexp_off[]			=   {".uc($_)."_REGEXP_OFF};\n";
    print "#else\n";
    print "static char *".lc($_)."_regexp_off[]			=   {NULL};\n";
    print "#endif\n\n";
}
    print "#include \"def_list_kinds.h\"\n";
    print "#include \"list_kinds.h\"\n";

foreach( @list){
    print "#ifdef   ".uc($_)."_LINE_COMMENT\n";
    print "pl_table[".ucfirst($_)."].line_cmt		= ".uc($_)."_LINE_COMMENT;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].line_cmt		= NULL;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_DELIMITERS\n";
    print "pl_table[".ucfirst($_)."].delimiters		= ".uc($_)."_DELIMITERS;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].delimiters		= NULL;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_STRING_CHARS\n";
    print "pl_table[".ucfirst($_)."].string_chars	= ".uc($_)."_STRING_CHARS;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].string_chars	= NULL;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_ESCAPE_CHAR\n";
    print "pl_table[".ucfirst($_)."].escape_char	= ".uc($_)."_ESCAPE_CHAR;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].escape_char	= NULL;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_DONT_CARE\n";
    print "pl_table[".ucfirst($_)."].dont_care	= TRUE;\n";
    print "#else\n";
    print "pl_table[".ucfirst($_)."].dont_care	= FALSE;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_IGNORE_TYPE\n";
    print "pl_table[".ucfirst($_)."].ignore_type	=  ".uc($_)."_IGNORE_TYPE;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].ignore_type	= NULL;\n";
    print "#endif\n\n";

    print "#ifdef   ".uc($_)."_EXCEPTION_RULE\n";
    print "pl_table[".ucfirst($_)."].exception_rule	= ".lc($_)."_exception_rule;\n";	
    print "#else\n";
    print "pl_table[".ucfirst($_)."].exception_rule	= NULL;\n";
    print "#endif\n\n";

    print "pl_table[".ucfirst($_)."].file_extensions	= (const char*const*)".lc($_)."_file_extensions;\n";	
    print "pl_table[".ucfirst($_)."].keywords		= (const char*const*)".lc($_)."_keywords;\n";	
    print "pl_table[".ucfirst($_)."].keywords1		= (const char*const*)".lc($_)."_keywords1;\n";	
    print "pl_table[".ucfirst($_)."].keywords2		= (const char*const*)".lc($_)."_keywords2;\n";	
    print "pl_table[".ucfirst($_)."].block_cmt_on	= (const char*const*)".lc($_)."_block_cmt_on;\n";	
    print "pl_table[".ucfirst($_)."].block_cmt_off	= (const char*const*)".lc($_)."_block_cmt_off;\n";	
    print "pl_table[".ucfirst($_)."].keyword_block_on	= (const char*const*)".lc($_)."_keyword_block_on;\n";	
    print "pl_table[".ucfirst($_)."].keyword_block_off	= (const char*const*)".lc($_)."_keyword_block_off;\n\n\n";	
    print "pl_table[".ucfirst($_)."].double_regexp_on	= (const char*const*)".lc($_)."_double_regexp_on;\n\n\n";	
    print "pl_table[".ucfirst($_)."].single_regexp_on	= (const char*const*)".lc($_)."_single_regexp_on;\n\n\n";	
    print "pl_table[".ucfirst($_)."].regexp_off		= (const char*const*)".lc($_)."_regexp_off;\n\n\n";	
}

